/*< ibefehle.c >*******************************************/
/* In diesem File befinden sich die alten und erweiterten */
/* Befehle des TXL-Interpreters. Compiler:Standard ANSI-C */
/*      (c) 1991  Ralf Morgenstern  &  toolbox            */
/**********************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "interp.h"

/* Bentigte Globalvariablen */
extern PRGZEILE *FirstLine;    /* erste Interpreterzeile  */
extern PRGZEILE *ActLine;   /* aktuelle interpret. Zeile  */
extern char *LinePos;    /* Zeilenposition der akt. Zeile */
extern int Steuer;  /* der aufrufenden Routine wird mit-  */
                    /* geteilt, um was es sich handelt.   */
extern char ScanBuffer[ZEILENLAENGE];
                           /* Ergebnisbuffer des Scanners */
extern int traceFlag;      /* Trace      ja / nein        */

/* cset() Zuweisen eines Wertes einer Variablen           */
int cset(void)
{
VAR Variable;

 Scan ();                     /* Name der Variablen lesen */
 if (Steuer == ALPHA) {
   strcpy (Variable.VarName,ScanBuffer);
                              /*  Variablennamen  setzen  */
   Scan ();
   if ((Steuer == SONDER) && (*ScanBuffer == '=')) {
   SetVar (&Variable);
}
  else
    serror ("Zuweisung erwartet! ");
}
 else
   serror ("Variablenname erwartet! ");

return (OK);
}

/* cdruck ():      Ausgabe von Werten auf dem Bildschirm
   dies knnen in der neuen Version auch Ausdrcke sein,
   diese werden dann zuerst berechnet, und das Ergebnis
   gedruckt
*/

int cdruck(void)
{
VAR Wert;

   if ( CalcExpression( &Wert ) == OK ){
   else
     switch ( Wert.VarType ) {
       case STRING:
       printf ( "%s",Wert.VarWert.variable.text );
       break;
       case  ZIFFER:
       printf ( "%d",Wert.VarWert.variable.integer );
       break;
       case  FLONUM :
        printf( "%f",Wert.VarWert.variable.Flotype );
       break;
       default :
       fatal_error("zu druckender Typ ist unbekannt\n" );
       break;
     }
   }
   else
     if ( Steuer == EOLCHAR ) printf("\n");
     else serror( "ungltiger Ausdruck" );

return (OK);
}

/* cgoto() --> weiter an einer anderen Stelle             */
extern int GetNextLine;        /* Nchste Zeile ausfhren */

int cgoto(void)
{
register int error, LineNumber;

 Scan ();
     /* Ist es eine Ziffer und gibt es ein Programm dazu? */
 if ((Steuer == ZIFFER) && FirstLine)
  {
   LineNumber = atoi (ScanBuffer); /* Calculate Jump Line */
   if (FindInsPos (LineNumber,&ActLine)) {
     ActLine = ActLine->PrevZeile;
     GetNextLine = FALSE;     /* Zeile ist aktuelle Zeile */
     return (OK);
   }
   else {
     printf ("\n Sprungziel nicht gefunden! ");
    return (FALSE);          /* Sprungziel nicht gefunden */
   }
 }
 else
   printf ("\n Kein Programm im Speicher! ");

return (OK);
}


/* cif () bedingte Ausfhrung von Befehlen */
int
cif()
{
int result = OK;

  /* Wenn Bedingung nicht erfllt, dann bernchste Zeile */
 if (CmpVar ()) {
    ActLine = ActLine->NextZeile; /* Dann-Zeile auswhlen */
    LinePos = ActLine->Zeile;             /* Zeilenanfang */
   result = InterpLine ();        /* Dann-Zweig ausfhren */
   ActLine = ActLine->NextZeile;
 }
 else
   if (ActLine->NextZeile)
    ActLine = ActLine->NextZeile;/* Sonst-Zweig ausfhren */
   else
     serror (" Kein Sonst-Zweig vorhanden! ");

return (result);
}


int crun ()
{
 if (FirstLine) {
   ActLine = FirstLine;
 /* alle Zeilen ausfhren oder bis Ende-Befehl bearbeiten */
   DoProgram ();
}
 else
   printf ("\n Kein Programm im Speicher! \n");

return (OK);
}

/* cende () ende des Interpreterprogramms */
extern PRGZEILE *FirstLine;

int
cende ()
{
 printf ("\n Normales Programmende... \n");
return (FALSE);
}


/*                       cexit: Ende des Interpreters     */

int cexit ()
{
  printf ("\n Interpreter verlassen... \n");
  exit (0);

return (OK);
}

int cmerke ()
{

return (OK);
}

/* clist: Auflisten des aktuellen Programms               */

int clist ()
{
PRGZEILE *FindZeile;
char     *Line;

/*   Wenn es eine erste Zeile gibt, setze Zeiger darauf   */
if ((FindZeile = FirstLine) != NULL) {
     printf ("\n    ### Aktuelles Programm auflisten: ###\n");
   while ( FindZeile)
          {
           ShowLine (FindZeile);
           FindZeile = FindZeile->NextZeile;
          }
 printf ("\n    ### Ende des aktuellen Programms! ###\n");
}

return (TRUE);
}

/* cload
   Laden eines Interpreterprogramms in den Hauptspeicher.
*/

int cload ()
{
 Scan();  /* Filename einlesen */
 if (Steuer == STRING)
    {
     SetFileName (ScanBuffer); /* Filename setzen */
     ReadProg ();    /* Programm einlesen */
    }
else
     serror ("Kein Filename angegeben! ");

return (OK);
}

/* csave
   Speichern eines Interpreterprogramms in den Hauptspeicher.
*/

int csave ()
{
Scan();  /* Filename einlesen */
 if (Steuer == STRING) {
     SetFileName (ScanBuffer); /* Filename setzen */
     WriteProg ();    /* Programm einlesen */
 }
 else
  serror ("Kein Filename angegeben! ");
return (OK);
}

/* cneu
   Aktuelles Programm aus dem Speicher lschen.
*/

int cneu ()
{
 ClearProg ();   /* Programm lschen */
 return (OK);
}

/*  ctrcon   Trace einschalten, d.h. Einzelschrittmodus   */

int ctrcon()
{
 printf("\nWachhund im Einsatz ( Hilfe mit <H> )\n");
 traceFlag = TRUE;
 return ( OK );
}

/* ctrcoff  Trace ausschalten */

int ctrcoff()
{
 traceFlag = FALSE;
 return ( OK );
}

/* cwdog :den Tracer fr EINE Kontrolle aufrufen
          es wird nicht in den Einzelschrittmodus geschaltet
*/

int cwdog()
{
  printf( "wuff wuff\n" );
  printf( "<H> bringt Hilfe\n" );
  Trace();
  return( OK );
}

/* creadvar :
   liest einen Wert ein, und weist ihn einer Variablen zu.
   Es  lassen  sich  auch  ganze Ausdrcke angeben, die dann
   zuerst berechnet werden.
   Strings sind dabei in " anzugeben.                     */

int creadvar()
{
VAR   NewVar;
char  wert[ZEILENLAENGE];

  Scan();
  if ( Steuer != ALPHA ){
    serror( "<lese> erwartet einen Variablenbezeichner" );
    return( FALSE );
  }

  putchar( '?' ); gets( wert );
  LinePos = wert; SkipChar();
  strcpy(NewVar.VarName,ScanBuffer );
  SetVar( &NewVar );
  
  return( OK );
}

/* ccopy : 
   Syntax : kopiere Stringausdruck "," Stringvariable ","
            num. Ausdruck
   
   kopiert Stringausdruck ab der durch den numerischen
   Ausdruck bestimmten Position in die Stringvariable

   Bsp.  kopiere "hey",s,2
         kopiert "hey" ab Position 2 in s
*/
   
int ccopy()
{
VAR     src,            /* zu kopierender Teil            */
        *dst;           /* Original, hier wird einkopiert */
size_t  dlen,newlen;
char    *s,*d;                 /* Hilfzeiger zum kopieren */
long    abda;                  /* ab  da einkopieren      */

  src.VarWert.variable.text = NULL;
  CalcExpression( &src );
  if ( src.VarType != STRING ){
    serror( "String erwartet als 1.P." ); return( FALSE );
  }
  if ( !TestComma()) return ( FALSE );
  
  if ( !GetStringVar( &dst )) return ( FALSE );
  Scan();                                  /* Komma lesen */
  if ( !TestComma()) return ( FALSE );
  if ( ! GetLong ( &abda )) return ( FALSE );
  
  dlen = strlen( dst->VarWert.variable.text );
                                    /* Lnge des Orignals */
  newlen = abda + strlen(src.VarWert.variable.text );
  if ( newlen > dlen ) 
    /* mehr Speicher anfordern,
       wenn String durch kopieren lnger                  */

    dst->VarWert.variable.text =
    realloc( dst->VarWert.variable.text,newlen );

  s = src.VarWert.variable.text;         /* dies hier ... */
  d = dst->VarWert.variable.text + abda; /*.. nach da ... */
  
  while ( *s != '\0' ) *d++ = *s++;       /* ... kopieren */
  if ( dlen < newlen ) *d ='\0' /* wenn neuer String lnger,
                                            '\0' anhngen */
  return( OK );
}

/* cins : 
   Syntax : einfuegen Stringausdruck ","
            Stringvariable "," num. Ausdruck
   
   fgt Stringausdruck ab der durch den numerischen Ausdruck
   bestimmten Position in die Stringvariable ein
   
   Bsp. einfuegen "hallo",s,3
        fgt "hallo" an Position 3 in s ein
*/

int cins()
{
VAR     src,        /* einzufgender Teil */
        *dst;       /* Original */
size_t  slen,dlen;
char    *s,*d,*ins; /*   Hilfszeiger schaffen u. kopieren */
long    abda;       /*   ab hier einfgen */

src.VarWert.variable.text = NULL;
CalcExpression( &src );
if ( src.VarType != STRING ){
    serror( "String erwartet als 1.P." ); return( FALSE );
}
if ( !TestComma()){ printf(" nach P1\n" ); return( FALSE );}
if ( !GetStringVar ( &dst )) return ( FALSE );
 Scan(); /* Komma lesen */
 if ( !TestComma()){ printf( "nach P2\n" );
      return ( FALSE ); }
 if ( ! GetLong( &abda )) return ( FALSE );
  
  dlen = strlen( dst->VarWert.variable.text );
  slen = strlen(src.VarWert.variable.text );

  /* der String wird lnger => mehr Speicher */
  dst->VarWert.variable.text =
       realloc( dst->VarWert.variable.text,slen+dlen );

  s = dst->VarWert.variable.text + ( dlen - 1 );
  d = dst->VarWert.variable.text + ( dlen + slen );
  *d = '\0'; d--;
  
  /* bis hier Platz schaffen */
  ins = dst->VarWert.variable.text + abda;
  
  while ( s >= ins ) *d-- = *s--;
                                  /* nach rechts schieben */
  
  s = src.VarWert.variable.text;
                                    /* das hier einsetzen */
  while ( *s != '\0' ) *ins++ = *s++;
                                 /* und endlich einsetzen */

  return( OK );
}

/* cdel :
   Syntax : loesche Stringvariable ","
            1. num. Ausdruck "," 2. num. Ausdruck

 Lscht die durch den  1. num. Ausdruck bestimmte Anzahl von
 Zeichen ab der durch den 2. Ausdruck bestimmten Position in
 der Stringvariablen.

   Bsp. loesche s,laenge(s)-1,1
        lscht alle Zeichen ab dem ersten
*/

int cdel()
{
VAR      *str;   /* in diesem String wird gelscht */
long     abda,   /* ab da wird gelscht */
         schieb; /* lschen durch linksschieben der Zeichen,
                    die hinter dem zu lsch.  Teil stehen */
char     *s,*d;  /* Hilfszeiger */
size_t   len;    /* ursprngliche Lnge */

  if ( !GetStringVar ( &str )) return ( FALSE );
  len = strlen( str->VarWert.variable.text );
  Scan(); /* Komma lesen */
  if ( !TestComma()) return ( FALSE );
  if ( !GetLong( &schieb )) return ( FALSE ); /* 2.P. */
  if ( !TestComma()) return ( FALSE );
  if ( !GetLong( &abda )) return ( FALSE ); /* 3.P. */

  if ( abda >= len ) return(OK);  /* hinter Stringende    */
  schieb += abda;                 /* von hier an schieben */
  if ( schieb > len ) schieb = len; /*aber nicht als vorh.*/

  d = str->VarWert.variable.text;
  s = d + schieb;  d += abda;
  while (( *d++ = *s++ ) != '\0' );/* schieb schieb hurra */
  *s = '\0';                       /* neues Ende          */

  return( OK );
}/* cdel */

/*************   Ende des Files IBEFEHLE.C  ***************/
